Description

Related issues:

Related to Database - Bug #5306: AdaptiveQuery sets a found record into the b... Test

Related to Database - Feature #3814: more schema metadata Closed

History

#1 - 05/10/2021 01:31 PM - Eric Faulhaber

- Related to Bug #5306: AdaptiveQuery sets a found record into the buffer twice in dynamic mode added

#2 - 05/10/2021 01:32 PM - Eric Faulhaber

Support for this VST was mostly implemented in #3814, however a few things remain to be addressed:

add update counters for field updates made by the BUFFER-COPY statement/method;

test/confirm temp-table support works and fix it if not;

test/confirm the retrieve counter is working correctly for AdaptiveQuery when in dynamic mode after #5306 is addressed.

For the #5306-related item, we know the retrieve counter is incorrectly incremented twice when AdaptiveQuery is in dynamic mode. This will be fixed

in #5306, not here, but once that is done, we need to test the VST is working correctly.

#3 - 05/10/2021 01:32 PM - Eric Faulhaber

- Related to Feature #3814: more schema metadata added

#4 - 05/10/2021 01:43 PM - Eric Faulhaber

Regarding the temp-table support, there are cases where conversion optimizes 4GL code which deletes temp-table records in a loop to use a bulk

delete operation in the converted result instead. This is an optimization worth preserving, but it means that the VST delete counter will be bypassed.

Some re-engineering of this optimization to use the result of a SQL DELETE operation to update the VST delete counter (or some other approach)

would be needed to deal with this. If not, this would be a permanent limitation/incompatibility with the 4GL's behavior.

#5 - 05/10/2021 02:25 PM - Igor Skornyakov

Eric Faulhaber wrote:

Support for this VST was mostly implemented in #3814, however a few things remain to be addressed:

add update counters for field updates made by the BUFFER-COPY statement/method;

test/confirm temp-table support works and fix it if not;
test/confirm the retrieve counter is working correctly for AdaptiveQuery when in dynamic mode after #5306 is addressed.

For the #5306-related item, we know the retrieve counter is incorrectly incremented twice when AdaptiveQuery is in dynamic mode. This will be

fixed in #5306, not here, but once that is done, we need to test the VST is working correctly.

 

Please note that we also have to make sure the counters are updated correctly in the presence of triggers (there are some tricky corner cases such

as  #3814-400)). This can be done after the issues described in #5289 will be resolved.

#6 - 11/16/2022 05:56 AM - Alexandru Lungu

- Assignee set to Dănuț Filimon

- Status changed from New to WIP
